package com.offcn.TestUnti;



import io.restassured.response.Response;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLConnection;
import java.util.List;
import java.util.Map;

public class HttpRequest {
    /**
     * 向指定URL发送GET方法的请求
     * 
     * @param url
     *            发送请求的URL
     * @param param
     *            请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
     * @return URL 所代表远程资源的响应结果
     */
	 public static void main(String[] args) {
//		 Response s=HttpRequest.sendGet("http://beta.alitest.eoffcn.com/template/addStuden/sign/a75f95ec663ebda46b51f0429b8706ff",
//	    			"user_info=[{\"package_id\":391634,\"username\":\"aaa\",\"phone\":15652333337,\"sso_id\":1}]&timestamp=1548839088&appid=jiaowu");
				Response re = HttpRequest.sendGet("http://beta.alitest.eoffcn.com/template/addStudent/sign/1c7e3e07567efbcd42b2fa6cd936784e",
	    			"user_info=[{\"package_id\":391634,\"username\":\"aaa\",\"phone\":15652333337,\"sso_id\":1}]&timestamp=1548841430&appid=jiaowu");

		 
		 System.out.println(re.getStatusCode());
		 System.out.println(re.asString());
		 //	    	try {
//	    		String s1=new String(s.getBytes(),"utf-8");
//				System.out.println(s1);
//			} catch (UnsupportedEncodingException e) {
//				e.printStackTrace();
//			}
	    }
	
    public static Response sendGet(String url, String param) {
        String result = "";
        String val="";
        BufferedReader in = null;
        Response re=null;
        try {
//            String urlNameString = url ;
            String urlNameString = url + "?" + param;
          //  System.out.println(urlNameString);
            URL realUrl = new URL(urlNameString);
            // 打开和URL之间的连接
            URLConnection connection = realUrl.openConnection();
            // 设置通用的请求属性
            connection.setRequestProperty("Authorization", "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpZCI6NSwicGhvbmUiOiIxODUxMTg1MjA0OSIsImlhdCI6MTQ4NzEzMjU0OX0.2aZ8FcfE52CYpXc4VUYjdfzzLzXwVOE-J8CnMlhUPic");
            connection.setRequestProperty("Content-Type", "application/json");
            // 建立实际的连接
            connection.connect();
            // 获取所有响应头字段
            Map<String, List<String>> map = connection.getHeaderFields();
            // 遍历所有的响应头字段
            for (String key : map.keySet()) {
            	String va=map.get(key).toString();
                //System.out.println(key + "--->" + va);
                if(va.contains("HTTP/1.1")){
                	val=va.toString().substring(10, va.toString().length()-4);
                	//System.out.println(val);
                	
                }
            }
            // 定义 BufferedReader输入流来读取URL的响应
            in = new BufferedReader(new InputStreamReader(
                    connection.getInputStream()));
           
            
            String line;
            while ((line = in.readLine()) != null) {
//            	 o.write(line+"\r\n");
                result += line;
                result += "\r\n";
            }
//            o.close();

            IoResponse ir=new IoResponse();
            re=ir.setResponseValue(val,result);
            
            
        } catch (Exception e) {
            System.out.println("发送GET请求出现异常！" + e);
            e.printStackTrace();
        }
        // 使用finally块来关闭输入流
        finally {
            try {
                if (in != null) {
                    in.close();
                }
            } catch (Exception e2) {
                e2.printStackTrace();
            }
        }
        return re;
    }

    /**
     * 向指定 URL 发送POST方法的请求
     * 
     * @param url
     *            发送请求的 URL
     * @param param
     *            请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
     * @return 所代表远程资源的响应结果
     */
   
    public static String sendPost(String url, String param) {
        PrintWriter out = null;
        BufferedReader in = null;
        String result = "";
        try {
            URL realUrl = new URL(url);
            // 打开和URL之间的连接
            URLConnection conn = realUrl.openConnection();
            // 设置通用的请求属性
            conn.setRequestProperty("Authorization", "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpZCI6NSwicGhvbmUiOiIxODUxMTg1MjA0OSIsImlhdCI6MTQ4NzEzMjU0OX0.2aZ8FcfE52CYpXc4VUYjdfzzLzXwVOE-J8CnMlhUPic");
            conn.setRequestProperty("Content-Type", "application/json");
            // 发送POST请求必须设置如下两行
            conn.setDoOutput(true);
            conn.setDoInput(true);
            // 获取URLConnection对象对应的输出流
            out = new PrintWriter(conn.getOutputStream());
            // 发送请求参数
            out.print(param);
            // flush输出流的缓冲
            out.flush();
            // 定义BufferedReader输入流来读取URL的响应
            in = new BufferedReader(
                    new InputStreamReader(conn.getInputStream()));
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
                result += "\r\n";
            }
        } catch (Exception e) {
            System.out.println("发送 POST 请求出现异常！"+e);
            e.printStackTrace();
        }
        //使用finally块来关闭输出流、输入流
        finally{
            try{
                if(out!=null){
                    out.close();
                }
                if(in!=null){
                    in.close();
                }
            }
            catch(IOException ex){
                ex.printStackTrace();
            }
        }
        return result;
    }    
}
